---
title: Using dynamic styling information
slug: Web/API/CSS_Object_Model/Using_dynamic_styling_information
tags:
  - API
  - Beginner
  - CSSOM
  - Guide
  - NeedsBeginnerUpdate
---
<p>{{DefaultAPISidebar("CSSOM")}}</p>

<p class="summary">The CSS Object Model (CSSOM), part of the DOM, exposes specific interfaces allowing manipulation of a wide amount of information regarding CSS. Initially defined in the <em>DOM Level 2 Style</em> recommendation, these interfaces forms now a specification, <em>CSS Object Model (CSSOM)</em> which aims at superseding it.</p>

<p>In many cases, and where possible, it really is best practice to dynamically manipulate classes via the {{ domxref("element.className", "className") }} property since the ultimate appearance of all of the styling hooks can be controlled in a single stylesheet. One's JavaScript code also becomes cleaner since instead of being dedicated to styling details, it can focus on the overall semantics of each section it is creating or manipulating, leaving the precise style details to the stylesheet. However, there are cases where actually obtaining or manipulating the rules can be useful (whether for whole stylesheets or individual elements), and that is described in further detail below. Note also that, as with individual element's DOM styles, when speaking of manipulating the stylesheets, this is not actually manipulating the physical document(s), but merely the internal representation of the document.</p>

<p>The basic <code>style</code> object exposes the {{domxref("Stylesheet")}} and the {{domxref("CSSStylesheet")}} interfaces. Those interfaces contain members like <code>insertRule</code>, <code>selectorText</code>, and <code>parentStyleSheet</code> for accessing and manipulating the individual style rules that make up a CSS stylesheet.</p>

<p>To get to the <code>style</code> objects from the <code>document</code>, you can use the {{domxref("document.styleSheets")}} property and access the individual objects by index (e.g., <code>document.styleSheets[0]</code> is the first stylesheet defined for the document, etc.).</p>

<h2 id="Modify_a_stylesheet_rule">Modify a stylesheet rule with CSSOM</h2>

<pre class="brush: html notranslate">&lt;html&gt;
&lt;head&gt;
&lt;title&gt;Modifying a stylesheet rule with CSSOM&lt;/title&gt;
&lt;style type="text/css"&gt;
body {
 background-color: red;
}
&lt;/style&gt;
&lt;script type="text/javascript"&gt;
var stylesheet = document.styleSheets[0];
stylesheet.cssRules[0].style.backgroundColor="blue";
&lt;/script&gt;
&lt;/head&gt;
&lt;body&gt;
The stylesheet declaration for the body's background color is modified via JavaScript.
&lt;/body&gt;
&lt;/html&gt;</pre>

<p>{{ EmbedLiveSample('Modify_a_stylesheet_rule') }}</p>

<p>The list of properties available in the DOM from the <code>style</code> property is given on the <a href="/en-US/docs/DOM/CSS" title="en/DOM/CSS">DOM CSS Properties List</a> page.</p>

<p>To modify styles to a document using CSS syntax, one can insert rules or insert {{HTMLElement("style")}} tags whose <code>innerHTML</code> property is set to the desired CSS.</p>

<h2 id="Modify_an_element_style">Modify an element's style</h2>

<p>The element {{domxref("HTMLElement.style", "style")}} property (see also the section "DOM Style Object" below) can also be used to get and set the styles on an element. However, this property only returns style attributes that have been set <em>in-line</em> (e.g, <code>&lt;td style="background-color: lightblue"&gt;</code> returns the string "<code>background-color:lightblue</code>", or directly for that element using <code>element.style.propertyName</code>, even though there may be other styles on the element from a stylesheet).</p>

<p>Also, when you set this property on an element, you override any styles that have been set elsewhere for that element's particular property you are setting. Setting the <code>border</code> property, for example, will override settings made elsewhere for that element's <code>border</code> property in the head section, or external style sheets. However, this will not affect any other property declarations for that element's styles, such as padding or margin or font, for example.</p>

<p>To change a particular element's style, you can adapt the following example for the element(s) you want to style.</p>

<pre class="brush: html notranslate">&lt;html&gt;
&lt;head&gt;
&lt;title&gt;simple style example&lt;/title&gt;

&lt;script type="text/javascript"&gt;

function alterStyle(elem) {
  elem.style.background = 'green';
}

function resetStyle(elemId) {
  elem = document.getElementById(elemId);
  elem.style.background = 'white';
}
&lt;/script&gt;

&lt;style type="text/css"&gt;
#p1 {
  border: solid blue 2px;
}
&lt;/style&gt;
&lt;/head&gt;

&lt;body&gt;

&lt;!-- passes a reference to the element's object as parameter 'this'. --&gt;
&lt;p id="p1" onclick="alterStyle(this);"&gt;
 Click here to change background color.
&lt;/p&gt;

&lt;!-- passes the 'p1' id of another element's style to modify. --&gt;
&lt;button onclick="resetStyle('p1');"&gt;Reset background color&lt;/button&gt;

&lt;/body&gt;
&lt;/html&gt;
</pre>

<p>{{ EmbedLiveSample('Modify_an_element_style') }}</p>

<p>The {{domxref("window.getComputedStyle", "getComputedStyle()")}} method on the <code>document.defaultView</code> object returns all styles that have actually been computed for an element. See <a href="/en/Gecko_DOM_Reference/Examples#Example_6:_getComputedStyle" title="en/Gecko_DOM_Reference/Examples#Example_6:_getComputedStyle">Example 6: getComputedStyle</a> in the examples chapter for more information on how to use this method.</p>

<h2 id="DOM_Style_Object">DOM Style Object</h2>

<p>The <code>style</code> object represents an individual style statement. Unlike the individual rules available from the <code><a href="/en/DOM/document.styleSheets" title="en/DOM/document.styleSheets">document.styleSheets</a></code> collection, the style object is accessed from the <code>document</code> or from the elements to which that style is applied. It represents the <em>in-line</em> styles on a particular element.</p>

<p>More important than the two properties noted here is the use of the <code>style</code> object to set individual style properties on an element:</p>

<div id="DOM_Style_Object_code_sample">
<pre class="brush: html notranslate">&lt;!DOCTYPE html&gt;
&lt;html&gt;
 &lt;head&gt;
  &lt;title&gt;style Property Example&lt;/title&gt;
  &lt;link rel="StyleSheet" href="example.css" type="text/css"&gt;
  &lt;script type="text/javascript"&gt;
    function stilo() {
      document.getElementById('d').style.color = 'orange';
    }
    function resetStyle() {
      document.getElementById('d').style.color = 'black';
    }
  &lt;/script&gt;
 &lt;/head&gt;

 &lt;body&gt;
  &lt;div id="d" class="thunder"&gt;Thunder&lt;/div&gt;
  &lt;button onclick="stilo()"&gt;Click here to change text color&lt;/button&gt;
  &lt;button onclick="resetStyle()"&gt;Reset text color&lt;/button&gt;
 &lt;/body&gt;
&lt;/html&gt;
</pre>
</div>

<p>{{ EmbedLiveSample('DOM_Style_Object_code_sample') }}</p>

<p>The <strong>media</strong> and <strong>type</strong> of the style may or may not be given.</p>

<h3 id="DOM_Style_Object_SetAttribue">Using the setAttribute method</h3>

<p>Note that you can also change style of an element by getting a reference to it and then use its <code><a href="/en/DOM/element.setAttribute" title="en/DOM/element.setAttribute">setAttribute</a></code> method to specify the CSS property and its value.</p>

<pre class="brush: js notranslate">var el = document.getElementById('some-element');
el.setAttribute('style', 'background-color:darkblue;');
</pre>

<p>Be aware, however, that <code>setAttribute</code> removes all other <code>style</code> properties that may already have been defined in the element's <code>style</code> object. If the <code><var>some-element</var></code> element above had an in–line <code>style</code> attribute of say <code>style="font-size: 18px"</code>, that value would be removed by the use of <code>setAttribute</code>.</p>
